package com.ruoyi.iit.service.impl;

import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.iit.domain.IitMyselfFile;
import com.ruoyi.iit.domain.IitPushUserRel;
import com.ruoyi.iit.mapper.IitMyselfFileMapper;
import com.ruoyi.iit.mapper.IitPushUserRelMapper;
import com.ruoyi.iit.service.IIitPushUserRelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 消息管理Service业务层处理
 *
 * @author Hao Li
 * @date 2025-04-11
 */
@Service
public class IitPushUserRelServiceImpl implements IIitPushUserRelService {
    @Autowired
    private IitPushUserRelMapper iitPushUserRelMapper;

    @Autowired
    private IitMyselfFileMapper iitMyselfFileMapper;

    /**
     * 查询消息管理
     *
     * @param id 消息管理主键
     * @return 消息管理
     */
    @Override
    public IitPushUserRel selectIitPushUserRelById(Long id) {
        return iitPushUserRelMapper.selectIitPushUserRelById(id);
    }

    /**
     * 查询消息管理 更新已读状态
     * @param id
     * @return
     */
    @Override
    public IitPushUserRel getMessageInfo(Long id) {
        // 查询数据
        IitPushUserRel result = iitPushUserRelMapper.getMessageInfo(id);
        // 更新已读状态
        if (result.getIsView() != 1) {
            result.setIsView(1);
            result.setViewTime(DateUtils.getNowDate());
            iitPushUserRelMapper.updateIitPushUserRel(result);
            // 将改文件保存至我的文件
            IitMyselfFile iitMyselfFile = new IitMyselfFile();
            iitMyselfFile.setFileId(result.getFileId());
            iitMyselfFile.setUserId(SecurityUtils.getUserId());
            iitMyselfFile.setCreateTime(DateUtils.getNowDate());
            iitMyselfFileMapper.insertIitMyselfFile(iitMyselfFile);
        }
        return result;
    }

    /**
     * 查询消息管理列表
     *
     * @param iitPushUserRel 消息管理
     * @return 消息管理
     */
    @Override
    public List<IitPushUserRel> selectIitPushUserRelList(IitPushUserRel iitPushUserRel) {
        return iitPushUserRelMapper.selectIitPushUserRelList(iitPushUserRel);
    }

    /**
     * 页面菜单消息管理列表
     *
     * @param iitPushUserRel 消息管理
     * @return 消息管理
     */
    @Override
    public List<IitPushUserRel> selectIitPushUserRelListV2(IitPushUserRel iitPushUserRel) {
        Long userId = SecurityUtils.getUserId();
        iitPushUserRel.setUserId(userId);

        return iitPushUserRelMapper.selectMyselfMessage(iitPushUserRel);
    }

    /**
     * 新增消息管理
     *
     * @param iitPushUserRel 消息管理
     * @return 结果
     */
    @Override
    public int insertIitPushUserRel(IitPushUserRel iitPushUserRel) {
        return iitPushUserRelMapper.insertIitPushUserRel(iitPushUserRel);
    }

    /**
     * 修改消息管理
     *
     * @param iitPushUserRel 消息管理
     * @return 结果
     */
    @Override
    public int updateIitPushUserRel(IitPushUserRel iitPushUserRel) {
        return iitPushUserRelMapper.updateIitPushUserRel(iitPushUserRel);
    }

    /**
     * 批量删除消息管理
     *
     * @param ids 需要删除的消息管理主键
     * @return 结果
     */
    @Override
    public int deleteIitPushUserRelByIds(Long[] ids) {
        return iitPushUserRelMapper.deleteIitPushUserRelByIds(ids);
    }

    /**
     * 删除消息管理信息
     *
     * @param id 消息管理主键
     * @return 结果
     */
    @Override
    public int deleteIitPushUserRelById(Long id) {
        return iitPushUserRelMapper.deleteIitPushUserRelById(id);
    }
}
